package com.nisum.omd;

import java.time.LocalDateTime;

import com.nisum.omd.service.OmdProducerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import com.nisum.omd.domain.Order;
import com.nisum.omd.service.RandomDataGeneratorImpl;

@Component
public class OrderGenerator implements CommandLineRunner{

	@Autowired
	RandomDataGeneratorImpl rdg;
	@Autowired
	Order order;

	@Autowired
	OmdProducerService omdProducerService;

	Boolean orderGenerateFlag =  true;
	
	public Boolean getOrderGenerateFlag() {
		return orderGenerateFlag;
	}

	public void setOrderGenerateFlag(Boolean orderGenerateFlag) {
		this.orderGenerateFlag = orderGenerateFlag;
	}

	public void run(String... args) throws Exception {

		  while(orderGenerateFlag){
		  order=getObjectData(order);
		  omdProducerService.sendMessage(order);
		  ObjectMapper objectMapper = new ObjectMapper();
		  objectMapper.registerModule(new JavaTimeModule());
		  objectMapper.disable(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS);
		  String jsonOrderStr = objectMapper.writeValueAsString(order);		
		  System.out.println(jsonOrderStr);
		  }
	}

	public Order getObjectData(Order order2) {
		
		LocalDateTime currentTime = LocalDateTime.now();
    	order.setOrderNum(rdg.generateOrderNumber());
		order.setCustomerId(rdg.generateCustomerId());
		order.setOrderDate(currentTime);
		order.setLineItem(rdg.genetateLineItem(order.getLineItem()));
        return order;
	}


}
